﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.RiskAssessment
<script src="~/Script/Master/Layout.js"></script>
<style>
    .domaincls {
        height: calc(100vh - 220px);
        padding: 0px 12px 15px;
        background: #f8f8f8;
        overflow-y: auto;
    }

        .domaincls .table_control {
            margin-top: 12px;
        }

    tr td:first-child {
        text-align: left;
    }

    .addbtn {
        background: #004ea8;
        color: #fff;
        width: 27px;
        height: 26px;
        padding: 5px 10px;
        margin-top: 44px;
        font-size: 12px;
        text-align: center;
        position: relative;
    }

        .addbtn:before {
            content: "";
            position: absolute;
            width: 14px;
            height: 2px;
            left: 6px;
            top: 12px;
            background: #fff;
        }

        .addbtn:after {
            content: "";
            position: absolute;
            width: 2px;
            height: 14px;
            left: 12px;
            top: 6px;
            background: #fff;
        }

    .remvbtn {
        background: #f00;
        color: #fff;
        width: auto;
        padding: 5px 10px;
        margin-top: 40px;
        font-size: 12px;
        width: 27px;
        height: 26px;
        text-align: center;
        position: relative;
    }

        .remvbtn:before {
            content: "";
            position: absolute;
            width: 14px;
            height: 2px;
            left: 6px;
            top: 12px;
            background: #fff;
        }
</style>
<section>
    @Html.HiddenFor(m => m.OrgId)
    @Html.HiddenFor(m => m.QuestionnaireID)
    @Html.HiddenFor(m => m.CategoryId)
    @Html.HiddenFor(m => m.CategoryName)
    <div class="right_section">
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Control Assessment for @Model.CategoryName
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="PerformCtrlAssessment" asp-controller="RiskAssessment" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-CategoryId="@Model.CategoryId" asp-route-QuestionnaireID="@Model.QuestionnaireID" asp-route-EnablerName="@Model.CategoryName">Back to Menu</a>
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="row" id="MainDiv">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="domaincls">
                                <div class="p-2 text-right">
                                    <a data-ajax="true" class="btn btn-warning" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="SendReminder" asp-controller="RiskAssessment" asp-area="ApplicationManagement" asp-route-OrgId="@Model.OrgId" asp-route-CategoryId="@Model.CategoryId" asp-route-QuestionnaireId="@Model.QuestionnaireID" asp-route-EnablerName="@Model.CategoryName">Send Reminder</a>
                                </div>
                                <div class="table_control">
                                    <table class="table" id="tblArtefacts">
                                        <thead>
                                            <tr>
                                                <th width="10%">Control Name</th>
                                                <th width="30%">Control Description</th>
                                                <th width="7%">Control Id</th>
                                                <th width="10%">Artefacts</th>
                                                <th width="10%">To be received from</th>
                                                <th width="5%">To be received by</th>
                                                <th width="7%">View Artifacts</th>
                                                <th width="10%">Artefact Receipt status</th>
                                                <th width="10%">Remarks</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @foreach (var item in Model.RCMControlByOrgLatestList)
                                            {
                                                <tr>
                                                    <td><input type="hidden" class="ICDId" value="@item.ICDID" />@item.ControlName</td>
                                                    <td><input type="hidden" value="@item.DomainID" />@item.ControlDescription</td>
                                                    <td><input type="hidden" value="@item.DomainName" />@item.ControlId</td>
                                                    <td>
                                                        <input type="hidden" value="@item.SubDomainID" />
                                                        <div style="margin-left:10px;">
                                                            <ol>
                                                                @if (!String.IsNullOrEmpty(item.ArtefactName))
                                                                {
                                                                    foreach (var item2 in item.ArtefactName.Split(","))
                                                                    {
                                                                        <li>@item2</li>
                                                                    }
                                                                }
                                                            </ol>
                                                        </div>
                                                    </td>
                                                    <td>
                                                        <select class="form-control">
                                                            <option value="0">Select Client User</option>
                                                            @foreach (var item3 in Model.ClientUserList)
                                                            {
                                                                <option value="@item3.Id">@item3.UserName</option>
                                                            }
                                                        </select>
                                                    </td>
                                                    <td><input type="date" class="form-control" id="StartDate" min="@DateTime.Now.ToString("yyyy-MM-dd")" max="@Model.AssScopeEndDate.ToString("yyyy-MM-dd")" /></td>
                                                    <td align="center"><i class="fa fa-folder-open fa-2x folderIcon" onclick="OpenModal(this)"></i></td>
                                                    <td>
                                                        <select id="ReceivedId" class="form-control">
                                                            <option value="0">Select</option>
                                                            <option value="1">Completely received</option>
                                                            <option value="2">Partially received</option>
                                                            <option value="3">Not received</option>
                                                        </select>
                                                    </td>
                                                    <td><input type="text" class="form-control" /></td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row pt-2">
                        <div class="col-1 offset-11">
                            <input type="button" class="btn btn-primary" value="Submit" onclick="SaveArtefacts()">
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

<div class="modal fade" id="DocumentBox" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-lg " role="document">
        <div class="modal-content">
            <div class="pb-2 mt-4 mb-2 border-bottom box_title pl-4" id="modaltext">Upload</div>
            <div class="modal-body">
                <div class="row justify-content-center">
                    <div class="col-8" id="dvMultiFiles">
                        <div class="row p-1">
                            <div class="col-10">
                                <input type="file" class="form-control files" onchange="ValidateFile(this)">
                            </div>
                            <div class="col-2">
                                <label class="addbtn" onclick="AddMoreFileRow(this)" style="margin-top:4px;cursor:pointer;"></label>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <a href="#DocumentBox" class="btn btn-danger" data-dismiss="modal" id="btn_Close">Close</a>
                <button type="button" class="btn btn-primary" id="btn_Submit" onclick="UploadFiles()">Submit</button>
            </div>
        </div>
    </div>
</div>

<script>
    function SaveArtefacts() {
        var Array = [], Files = [], no = 0, sn = 0;
        $('#tblArtefacts tbody tr').each((i, tr) => {
            var recFromId = Number($(tr).find('td:eq(4) select').val())
            if (!recFromId > 0) return;
            Array[++no] = {
                ICDId: Number($(tr).find('td:eq(0) input').val()),
                RecFromId: Number($(tr).find('td:eq(4) select').val()),
                RecByDate: $(tr).find('td:eq(5) input').val(),
                RecStatus: Number($(tr).find('td:eq(7) select').val()),
                Remark: $(tr).find('td:eq(8) input').val(),
            }
        })
        $('#tblArtefacts tbody tr').each((i, tr) => {
            debugger;
            var ICDId = Number($(tr).find('td:eq(0) input').val());
            var attr = $(tr).find('td:eq(6)').attr('input');
            if (attr === 'undefined') return;
            $(tr).find('td:eq(6) input').each((j, ele) => {
                Files[++sn] = {
                    ICDId: ICDId,
                    ImagePath: $(ele).val(),
                }
            })
        })
        if (Array.length > 0) {
            var model = {
                OrgId: $("#OrgId").val(),
                CategoryId: $("#CategoryId").val(),
                QuestionnaireId: $("#QuestionnaireID").val(),
                ArtefactsXML: JSON.stringify(Array),
                ImagesXML: Files.length > 0 ? JSON.stringify(Files) : null
            }
            $.post('/ApplicationManagement/RiskAssessment/SaveUpdateArtefacts', { model: model }, function (res) {
                if (res.isSuccess) {
                    toastr.success('Saved successfully.');
                } else {
                    toastr.error('Something went wrong!');
                }
            })
        } else {
            toastr.warning('Don\'t have any request');
        }
    }
    function UploadFiles(eq) {
        if (window.FormData !== undefined) {
            var formData = new FormData();
            $(".files").each((i, ele) => {
                $.each(ele.files, (j, file) => {
                    formData.append(file.name, file);
                })
            })
            $.ajax({
                url: '/ApplicationManagement/RiskAssessment/UploadFiles',
                type: 'post',
                contentType: false,
                processData: false,
                data: formData,
                success: function (res) {
                    if (res.length > 0) {
                        $.each(res, (i, item) => {
                            $('.folderIcon').eq(eq).closest('td')
                                .append('<input type="hidden" value="' + item + '" />');
                        })
                        $('#btn_Close').click();
                        toastr.success('Files have saved successfully.')
                    }
                },
                error: function (err) {
                    toastr.error(err.statusText);
                }
            })
        } else {
            alert("FormData is not supported.");
        }
    }
    function ValidateFile($this) {

    }
    function RemoveMoreFileRow($this) {
        $($this).closest('.row').remove();
    }
    function AddMoreFileRow($this) {
        var row = '<div class="row p-1">' +
            '<div class="col-10">' +
            '<input type="file" class="form-control files" onchange="ValidateFile(this)">' +
            '</div>' +
            '<div class="col-2">' +
            '<label class="remvbtn" onclick="RemoveMoreFileRow(this)" style="margin-top:4px;cursor:pointer"></label>' +
            '</div>' +
            '</div>';
        $($this).closest('#dvMultiFiles').append(row);
    }
    function OpenModal($this) {
        var eq = $($this).index('.folderIcon');
        $('#dvMultiFiles').find('[type="file"]').val('');
        var length = $('#dvMultiFiles').find('[type="file"]').length;
        if (length > 0)
            $('#dvMultiFiles').find('.row').not(':eq(0)').remove();
        $('#btn_Submit').attr('onclick', 'UploadFiles(' + eq + ')');
        $('#DocumentBox').modal('show');
    }
</script>
